﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Xml;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string callback = ClientScript.GetCallbackEventReference(EncryptButton,
            "arg", "updateText", "context", true);
        ClientScript.RegisterClientScriptBlock(GetType(),
            "CallEncrypt", "function CallEncrypt(arg, context) { " + callback + " }", true);
        callback = ClientScript.GetCallbackEventReference(DecryptButton,
                    "arg", "updateText", "context", true);
        ClientScript.RegisterClientScriptBlock(GetType(),
            "CallDecrypt", "function CallDecrypt(arg, context) { " + callback + " }", true);
    }

    /// <summary>
    /// 入力されたパスワードを返す
    /// </summary>
    public string PasswordData
    {
        get { return Password.Text; }
    }
    /// <summary>
    /// 入力された暗号化対象テキストを返す
    /// </summary>
    public string TextData
    {
        get { return Text.Text; }
    }

    SymmetricAlgorithm createAlgorithm()
    {
        SymmetricAlgorithm rijndael = RijndaelManaged.Create();
        int blocksize = rijndael.BlockSize / 8;
        byte[] password = Encoding.UTF8.GetBytes(PasswordData);
        byte[] key = new byte[blocksize];
        Array.Copy(password, key, (password.Length > blocksize) ? blocksize : password.Length);
        rijndael.Key = key;
        rijndael.IV = key;
        return rijndael;
    }
    string Cut(string s)
    {
        StringBuilder sb = new StringBuilder(s);
        for (int i = 32; i < sb.Length; i += 32)
        {
            sb.Insert(i, '\n');
            i++;
        }
        return sb.ToString();
    }

    protected void EncryptButton_Click1(object sender, EventArgs e)
    {
        ch5.EventButton.XmlEventArgs arg = (ch5.EventButton.XmlEventArgs)e;
        Password.Text = arg.Document["data"]["password"].InnerText;
        string text = arg.Document["data"]["text"].InnerText;
        MemoryStream ms = new MemoryStream();
        using (CryptoStream cs = new CryptoStream(ms, createAlgorithm().CreateEncryptor(), CryptoStreamMode.Write))
        {
            byte[] data = Encoding.UTF8.GetBytes(text);
            cs.Write(data, 0, data.Length);
            cs.FlushFinalBlock();
            arg.Result = Cut(Convert.ToBase64String(ms.ToArray()));
        }
    }
    protected void DecryptButton_Click1(object sender, EventArgs e)
    {
        ch5.EventButton.XmlEventArgs arg = (ch5.EventButton.XmlEventArgs)e;
        Password.Text = arg.Document["data"]["password"].InnerText;
        string text = arg.Document["data"]["text"].InnerText;
        MemoryStream ms;
        try
        {
            ms = new MemoryStream(Convert.FromBase64String(text));
        }
        catch (FormatException)
        {
            return;
        }
        try
        {
            using (CryptoStream cs = new CryptoStream(ms, createAlgorithm().CreateDecryptor(), CryptoStreamMode.Read))
            {
                byte[] result = new byte[ms.Length];
                cs.Read(result, 0, (int)ms.Length);
                arg.Result = Encoding.UTF8.GetString(result);
            }
        }
        catch (CryptographicException)
        {
        }

    }
}

